/*
 * Copyright (c) 2001-2004 MUSIC TECHNOLOGY GROUP (MTG)
 *                         UNIVERSITAT POMPEU FABRA
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

// generated by Fast Light User Interface Designer (fluid) version 2.00

#ifndef Fl_Knob_H
#define Fl_Knob_H
#include <FL/Fl.H>
#include <FL/Fl_Valuator.H>
#include <FL/fl_draw.H>

#include "CLAM_Math.hxx"

#include <stdlib.h>


class Fl_Knob : public Fl_Valuator {
public:
	enum Fl_Knobtype {DOTLIN=0,DOTLOG_1,DOTLOG_2,DOTLOG_3,LINELIN,LINELOG_1,LINELOG_2,LINELOG_3};
private:
	int _type;
	double _percent;
	int _scaleticks;
	short a1,a2;
public:
	Fl_Knob(int xx,int yy,int ww,int hh, const char* l);
	~Fl_Knob();
private:
	void draw();
	int handle(int  event);
public:
	void type(int ty);
private:
	void shadow(const int offs,const uchar r,uchar g,uchar b);
	void draw_scale(const int ox,const int oy,const int side);
	void draw_cursor(const int ox,const int oy,const int side);
public:
	void cursor(const int pc);
	void scaleticks(const int tck);
};
#endif
